namespace Brjnk.Common
{
    using System;
    using System.Windows;

    /// <summary>
    /// Tda implementujc IWeakEventListener, kter pi vyvoln WeakEvent zavol pedan delegt.
    /// </summary>
    public class WeakEventListener : IWeakEventListener
    {
        private ReceiveWeakEventDelegate handler;

        public WeakEventListener(ReceiveWeakEventDelegate handler)
        {
            if (handler == null) throw new ArgumentNullException();
            this.handler = handler;
        }

        public bool ReceiveWeakEvent(Type managerType, object sender, EventArgs e)
        {
            return handler(managerType, sender, e);
        }
    }

    public delegate bool ReceiveWeakEventDelegate(Type managerType, object sender, EventArgs e);
}