﻿namespace Brjnk.CoordinateSystem2D
{
    public struct LabelInfo
    {
        private LabelSize size;
        private double value;
        private string text;

        public LabelSize Size { get { return size; } }

        public double Value { get { return value; } }

        public string Text { get { return text; } }

        public LabelInfo(LabelSize size, double value, string text)
        {
            this.size = size;
            this.value = value;
            this.text = text;
        }
    }

    public enum LabelSize
    {
        /// <summary>
        /// Malá čárka na ose bez popisku (např. hodnota 0.1)
        /// </summary>
        Small = 0,

        /// <summary>
        /// Střední čárka na ose bez popisku (např. hodnota 0.5)
        /// </summary>
        Medium = 1,

        /// <summary>
        /// Velká čárka na ose s popiskem (např. hodnota 1)
        /// </summary>
        Big = 2,

        /// <summary>
        /// Velká čárka s popiskem (např. hodnota 0).
        /// </summary>
        Large = 3
    }
}