﻿using System;
using System.Windows;
using System.Windows.Controls;

namespace Brjnk.CoordinateSystem2D
{
    public class OpenPopupEventArgs : EventArgs
    {
        private Panel customContent;

        public OpenPopupEventArgs(Point relative, Point position, Panel customContentDestination)
        {
            this.RelativePosition = relative;
            this.Position = position;
            this.customContent = customContentDestination;
        }

        public void AddCustomContent(UIElement element)
        {
            customContent.Children.Add(element);
        }

        /// <summary>
        /// Obrazovkové souřadnice vzhledem k levému hornímu rohu
        /// </summary>
        public Point RelativePosition { get; protected set; }

        /// <summary>
        /// Souřadnice v soustavě souřadnic
        /// </summary>
        public Point Position { get; protected set; }
    }
}