namespace Brjnk.CoordinateSystem2D
{
    using System;
    using System.Windows;
    using System.Windows.Media.Animation;

    /// <summary>
    /// Animace pro plynulou zmnu pohledu Area2D. Animuje ViewDefinition.
    /// </summary>
    internal class ViewAnimation : AnimationTimeline
    {
        public override Type TargetPropertyType
        {
            get { return typeof(ViewInfoBase.ViewDefinition); }
        }

        public ViewInfo.ViewDefinition From
        {
            get { return (ViewInfo.ViewDefinition)GetValue(FromProperty); }
            set { SetValue(FromProperty, value); }
        }

        public static readonly DependencyProperty FromProperty =
            DependencyProperty.Register("From", typeof(ViewInfo.ViewDefinition), typeof(ViewAnimation), new UIPropertyMetadata());

        public ViewInfo.ViewDefinition To
        {
            get { return (ViewInfo.ViewDefinition)GetValue(ToProperty); }
            set { SetValue(ToProperty, value); }
        }

        public static readonly DependencyProperty ToProperty =
            DependencyProperty.Register("To", typeof(ViewInfo.ViewDefinition), typeof(ViewAnimation), new UIPropertyMetadata());

        protected override System.Windows.Freezable CreateInstanceCore()
        {
            return new ViewAnimation();
        }

        public override object GetCurrentValue(object defaultOriginValue, object defaultDestinationValue, AnimationClock animationClock)
        {
            var deltaCenter = To.Center - From.Center;
            var deltaZoomX = To.ZoomX - From.ZoomX;
            var deltaZoomY = To.ZoomY - From.ZoomY;
            var k = animationClock.CurrentProgress ?? 0.0;
            return new ViewInfo.ViewDefinition(From.Center + deltaCenter * k, From.ZoomX + deltaZoomX * k, From.ZoomY + deltaZoomY * k); ;
        }
    }
}