namespace Brjnk.GpxExplorer.Computing
{
    using Brjnk.Common;
    using Brjnk.GpxExplorer.ViewModel;

    /// <summary>
    /// </summary>
    public class AccelerationCalculator
    {
        public static void Calculate(ITrackPoint lastWithTime, bool isLastInSegment, ITrackPoint point)
        {
            // var lastWithTime = context.LastWithTime;

            //zrychlen je vdy potno pro pedchoz bod, tento dek vynuluje zrychlen poslednho bodu stopy
            if (point.DurationJoined.HasValue)
            {
                point.HasAcceleration = false;
                point.AccelerationJoined = TrackPointAttributeValue<Acceleration>.CreateUnset();
            }
            else
            {
                point.HasAcceleration = true;
                point.AccelerationJoined = TrackPointAttributeValue<Acceleration>.CreateUnavailable();
            }

            if (lastWithTime != null && lastWithTime.SpeedJoined.IsUnset != true && point.DurationJoined.HasValue)
            {
                var time = (point.DurationJoined.Value - lastWithTime.DurationJoined.Value).TotalSeconds
                    + lastWithTime.DurationDeltaJoined.Value.TotalSeconds / 2
                    - point.DurationDeltaJoined.Value.TotalSeconds / 2;

                double a = (point.SpeedJoined.Value - lastWithTime.SpeedJoined.Value) / time;
                lastWithTime.AccelerationJoined = (Acceleration)a;
                if (isLastInSegment && lastWithTime.SpeedJoined.IsUnset == false)
                {
                    lastWithTime.HasAcceleration = true;
                }
            }
        }
    }
}