﻿using System;
using Brjnk.Common;

namespace Brjnk.GpxExplorer.Computing
{
    public class FindPositionArgs
    {
        public Distance Limit { get; protected set; }

        public Distance ReturnAgainLimit { get; protected set; }

        public bool SearchInGaps { get; protected set; }

        /// <param name="returnAgainLimit">Pokud se trasa od bodu vzdálí více než je tato hodnota, bude probíhat znovu vyhledávání a metoda vrátí více výsledků.</param>
        public FindPositionArgs(Distance limit, Distance returnAgainLimit, bool searchInGaps)
        {
            if (Limit > returnAgainLimit) throw new ArgumentException("Limit musí být menší než ReturnAgainLimit");
            SearchInGaps = searchInGaps;
            Limit = limit;
            ReturnAgainLimit = returnAgainLimit;
        }
    }
}