namespace Brjnk.GpxExplorer.Computing
{
    using Brjnk.Common;
    using Brjnk.GpxExplorer.ViewModel;

    /// <summary>
    /// </summary>
    public class SlopeCalculator
    {
        public static void Calculate(ITrackPoint lastWithHeight, bool isLastInSegment, ITrackPoint point)
        {
            //vpoet stoupn
            if (lastWithHeight != null && point.Elevation.HasValue)
            {
                var delta = point.Elevation.Value - lastWithHeight.Elevation.Value;
                var slope = (Slope)(delta / (point.DistanceJoined.Value - lastWithHeight.DistanceJoined.Value));
                point.SlopeJoined = slope;
                if (isLastInSegment) point.HasSlope = true;
                else point.HasSlope = false;
            }
            else if (point.Elevation.HasValue)
            {
                point.SlopeJoined = TrackPointAttributeValue<Slope>.CreateUnset();
                point.HasSlope = false;
            }
            else
            {
                point.SlopeJoined = TrackPointAttributeValue<Slope>.CreateUnavailable();
                point.HasSlope = true;
            }
        }
    }
}