namespace Brjnk.GpxExplorer.Computing
{
    using Brjnk.Common;
    using Brjnk.GpxExplorer.ViewModel;

    /// <summary>
    /// </summary>
    public class SpeedCalculator
    {
        public static void Calculate(ITrackPoint lastWithTime, bool isLastInSegment, ITrackPoint point)
        {
            // var lastWithTimeInSegment = context.LastWithTimeInSegment;
            // var lastWithTime = context.LastWithTime;

            //vpoet rychlosti
            if (lastWithTime != null && point.DurationJoined.HasValue)
            {
                double speed = (point.DistanceJoined.Value - lastWithTime.DistanceJoined.Value)
                    / (point.DurationJoined.Value - lastWithTime.DurationJoined.Value).TotalSeconds;
                point.SpeedJoined = (Speed)speed;
                if (isLastInSegment) point.HasSpeed = true;
                else point.HasSpeed = false;
            }
            else if (point.DurationJoined.HasValue)
            {
                point.HasSpeed = false;
                point.SpeedJoined = TrackPointAttributeValue<Speed>.CreateUnset();
            }
            else
            {
                point.HasSpeed = true;
                point.SpeedJoined = TrackPointAttributeValue<Speed>.CreateUnavailable();
            }
        }
    }
}