namespace Brjnk.GpxExplorer.Computing
{
    using Brjnk.Common;
    using Brjnk.GpxExplorer.ViewModel;

    /// <summary>
    /// </summary>
    public class VerticalSpeedCalculator
    {
        public static void Calculate(ITrackPoint lastWithTimeHeight, bool isLastInSegment, ITrackPoint point)
        {
            //  var lastWithTimeHeightInSegment = context.LastWithTimeElevationInSegment;
            // var lastWithTimeHeight = context.LastWithTimeElevation;

            //vpoet vertikln rychlosti
            if (lastWithTimeHeight != null && point.DurationJoined.HasValue && point.Elevation.HasValue)
            {
                double speed = (point.Elevation.Value - lastWithTimeHeight.Elevation.Value)
                    / (point.DurationJoined.Value - lastWithTimeHeight.DurationJoined.Value).TotalSeconds;
                point.VerticalSpeedJoined = (Speed)speed;
                if (isLastInSegment) point.HasVerticalSpeed = true;
                else point.HasVerticalSpeed = false;
            }
            else if (point.DurationJoined.HasValue && point.Elevation.HasValue)
            {
                point.VerticalSpeedJoined = TrackPointAttributeValue<Speed>.CreateUnset();
                point.HasVerticalSpeed = false;
            }
            else
            {
                point.VerticalSpeedJoined = TrackPointAttributeValue<Speed>.CreateUnavailable();
                point.HasVerticalSpeed = true;
            }
        }
    }
}