namespace Brjnk.GpxExplorer.Data.GPX.SerializationClasses
{
    /// <summary>
    /// </summary>
    public class SerializationOptions
    {
        static SerializationOptions()
        {
            SerializationOptions.GarminVersion = GarminExtensionVersions.v3;
            SerializationOptions.GpxVersion = GpxVersion.v1_1;
            SerializationOptions.GroundspeakVersion = GroundspeakExtensionVersions.v1_0;
        }

        public static void SetGeocachingExport()
        {
            //GarminVersions = GarminExtensionVersions.v3;
            GpxVersion = SerializationClasses.GpxVersion.v1_0;
            GroundspeakVersion = GroundspeakExtensionVersions.v1_0;
        }

        public static void SetDefaultExport()
        {
            GarminVersion = GarminExtensionVersions.v3;
            GpxVersion = SerializationClasses.GpxVersion.v1_1;
            GroundspeakVersion = GroundspeakExtensionVersions.v1_0;
        }

        public static GarminExtensionVersions GarminVersion { get; set; }

        public static GroundspeakExtensionVersions GroundspeakVersion { get; set; }

        public static GpxVersion GpxVersion { get; set; }
    }

    public enum GarminExtensionVersions
    {
        v1 = 1,
        v2 = 2,
        v3 = 4
    }

    public enum GroundspeakExtensionVersions
    {
        v1_0 = 1,
        v1_1 = 2
    }

    public enum GpxVersion
    {
        v1_0 = 1,
        v1_1 = 2
    }
}