namespace Brjnk.GpxExplorer.Data.ImportExport
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using Brjnk.GpxExplorer.ViewModel;

    /// <summary>
    /// </summary>
    public interface IDataReader
    {
        DataReaderResult Load(Stream data);
    }

    public class DataReaderResult
    {
        public DataReaderResult(IEnumerable<WaypointVM> waypoints, IEnumerable<RouteVM> routes, IEnumerable<TrackVM> tracks, string message, Exception ex)
        {
            this.Waypoints = waypoints;
            this.Routes = routes;
            this.Tracks = tracks;
            this.Message = message;
            this.Exception = ex;
        }

        public DataReaderResult(Exception ex)
        {
            this.Exception = ex;
        }

        public IEnumerable<WaypointVM> Waypoints { get; private set; }

        public IEnumerable<RouteVM> Routes { get; private set; }

        public IEnumerable<TrackVM> Tracks { get; private set; }

        public Exception Exception { get; private set; }

        public string Message { get; private set; }
    }
}