namespace Brjnk.GpxExplorer.Data
{
    using System;
    using System.ComponentModel;
    using Brjnk.Common;

    /// <summary>
    /// </summary>
    public abstract class RoutePoint : INotifyPropertyChanged, ICloneable
    {
        // Pi upravovn tto tdy mus bt nov vlstnosti pidny do metody ConvertTo
        // Metoda ConvertTo zajiuje konverzi mezi rznmi potomky tto tdy (nap. pokud jsou data z rznch zdroj / typ souboru)
        // Metoda ConvertTo zkopruje vlastnosti definovan touto tdou

        public abstract GpsCoordinates Position { get; set; }

        public abstract Distance? Elevation { get; set; }

        public abstract DateTime? Time { get; set; }

        public T ConvertTo<T>() where T : RoutePoint
        {
            //Dopotan hodnoty nejsou koprovny
            var instance = Activator.CreateInstance(typeof(T)) as RoutePoint;
            instance.Position = Position;
            instance.Elevation = Elevation;
            instance.Time = Time;
            return instance as T;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null) PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        public abstract object Clone();
    }
}