namespace Brjnk.GpxExplorer.Data
{
    using System;
    using System.ComponentModel;
    using Brjnk.Common;

    /// <summary>
    /// </summary>
    public abstract class TrackPoint : ICloneable, INotifyPropertyChanged
    {
        public abstract GpsCoordinates Position { get; set; }

        public abstract Distance? Elevation { get; set; }

        public abstract DateTime? Time { get; set; }

        public TrackSegment Parent { get; internal set; }

        public T ConvertTo<T>() where T : TrackPoint
        {
            //Dopotan hodnoty nejsou koprovny
            var instance = Activator.CreateInstance(typeof(T)) as TrackPoint;
            instance.Position = Position;
            instance.Elevation = Elevation;
            instance.Time = Time;
            return instance as T;
        }

        public abstract object Clone();

        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null) PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}