﻿using System;
using System.Windows;
using System.Windows.Data;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml;
using Brjnk.Common;
using Brjnk.GpxExplorer.Workspace;

namespace Brjnk.GpxExplorer.UI
{
    /// <summary>
    /// Interaction logic for SearchPlaceWindow.xaml
    /// </summary>
    public partial class SearchPlaceWindow : Window
    {
        public SearchPlaceWindow()
        {
            InitializeComponent();
        }

        private static Uri GetUrl(string value)
        {
            if ((object)value == null) return new Uri(string.Empty);
            //  var name = System.Web.HttpUtility.UrlEncode(value.ToString());
            var uri = string.Format("http://api.geonames.org/search?q={0}&maxRows=50&username=gpxexplorer", value);
            return new Uri(uri);
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var xmlProvider = (XmlDataProvider)this.FindResource("xmlData");
            xmlProvider.Source = GetUrl(input.Text);
            xmlProvider.Refresh();
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            this.DialogResult = false;
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            foreach (XmlElement element in items.SelectedItems)
            {
                string name = element.GetElementsByTagName("toponymName").Item(0).InnerText;
                double lat = double.Parse(element.GetElementsByTagName("lat").Item(0).InnerText, System.Globalization.CultureInfo.InvariantCulture);
                double lon = double.Parse(element.GetElementsByTagName("lng").Item(0).InnerText, System.Globalization.CultureInfo.InvariantCulture);
                AddRequest(name, new GpsCoordinates(lat, lon));
            }
            this.DialogResult = true;
        }

        private void AddRequest(string name, GpsCoordinates coordinates)
        {
            App.Instance.Workspace.SearchService.SearchedItems.Add(new SearchPlaceRequest(name)
            {
                MaxDistance = searchArgs.Limit,
                ShowAgainDistance = searchArgs.SearchAgainLimit,
                Position = coordinates,
                SearchInGaps = searchArgs.SearchInGaps,
                Color1 = colorPicker.Color,
                Color2 = Colors.Black
            });
        }

        private void Image_MouseDown(object sender, MouseButtonEventArgs e)
        {
            System.Diagnostics.Process.Start("http://www.geonames.org/");
        }
    }
}