namespace Brjnk.GpxExplorer.ViewModel
{
    using Brjnk.Common;
    using Brjnk.GpxExplorer.Data;
    using Brjnk.GpxExplorer.Workspace;
    using Brjnk.MVVM;

    public class RoutePointVM : Wrapper<RoutePoint>, IGpsData, ISearchResults, IPoint, ISelectable
    {
        public RoutePointVM(RoutePoint source) : base(source) { }

        public ObservableCollectionEx<SearchResult> SearchResults { get; set; }

        private int number;

        public int Number
        {
            get { return number; }
            set { number = value; OnPropertyChanged("Number"); }
        }

        private Distance distance;

        public Distance Distance
        {
            get { return distance; }
            set { distance = value; OnPropertyChanged("Distance"); }
        }

        private Distance distanceDelta;

        public Distance DistanceDelta
        {
            get { return distanceDelta; }
            set { distanceDelta = value; OnPropertyChanged("DistanceDelta"); }
        }

        private Azimuth? azimuth;

        public Azimuth? Azimuth
        {
            get { return azimuth; }
            set { azimuth = value; OnPropertyChanged("Azimuth"); }
        }

        public GpsCoordinates GetPos()
        {
            return Source.Position;
        }

        public void GetBounds(BoundsBuilder builder)
        {
            builder.AddPoint(Source.Position);
        }

        private bool isSelected;

        public bool IsSelected
        {
            get { return isSelected; }
            set { isSelected = value; OnPropertyChanged("IsSelected"); }
        }
    }
}