namespace Brjnk.GpxExplorer.ViewModel
{
    using Brjnk.Common;
    using Brjnk.GpxExplorer.Data;
    using Brjnk.GpxExplorer.Workspace;
    using Brjnk.MVVM;

    /// <summary>
    /// </summary>
    public class WaypointVM : Wrapper<Waypoint>, IPoint, IGpsData, ISearchResults, ISelectable, IHideable
    {
        public WaypointVM(Waypoint source)
            : base(source)
        {
        }

        public ObservableCollectionEx<SearchResult> SearchResults { get; set; }

        public GpsCoordinates GetPos()
        {
            return Source.Position;
        }

        private bool isSelected;

        public bool IsSelected
        {
            get { return isSelected; }
            set { isSelected = value; OnPropertyChanged("IsSelected"); }
        }

        private bool isVisible = true;

        public bool IsVisible
        {
            get { return isVisible; }
            set { isVisible = value; OnPropertyChanged("IsVisible"); }
        }

        public void GetBounds(BoundsBuilder builder)
        {
            builder.AddPoint(GetPos());
        }
    }
}