namespace Brjnk.GpxExplorer.WPF
{
    using System;
    using System.Windows.Data;

    /// <summary>
    /// Invertuje hodnotu.
    /// Podporuje typy int, float, double, bool.
    /// </summary>
    public class InvertConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return Invert(value, targetType);
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return Invert(value, targetType);
        }

        private object Invert(object value, Type targetType)
        {
            if (value is bool)
                return !((bool)value);
            else if (value is int)
                return -((int)value);
            else if (value is float)
                return -((float)value);
            else if (value is double)
                return -((double)value);
            else throw new InvalidOperationException("Nepodporovan typ k inverzi");
        }
    }
}