namespace Brjnk.GpxExplorer.WPF
{
    using System;
    using System.Windows.Data;

    /// <summary>
    /// </summary>
    public class NullableConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if ((object)value == null)
                //vrtit vchoz hodnotu hodnotovho typu nebo null, pokud se jedn o referenn typ
                return targetType.IsValueType ? Activator.CreateInstance(targetType) : null;

            //var converter = TypeDescriptor.GetConverter(value.GetType());
            //try
            //{
            //    if (converter.CanConvertTo(targetType))
            //    {
            //        return converter.ConvertTo(value, targetType);
            //    }
            //}
            //catch { }
            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value is string &&
                string.IsNullOrEmpty(value as string) &&
                targetType.IsGenericType &&
                targetType.GetGenericTypeDefinition() == typeof(Nullable<>))
                return null;

            //var converter = TypeDescriptor.GetConverter(targetType);
            //try
            //{
            //    if (converter.CanConvertFrom(value.GetType()))
            //    {
            //        return converter.ConvertFrom(value);
            //    }
            //}
            //catch { }
            return value;
        }
    }
}