namespace Brjnk.GpxExplorer.Workspace
{
    using System.Collections.Generic;
    using System.Windows.Media;
    using Brjnk.GpxExplorer.Data.ImportExport;

    /// <summary>
    /// Extern aplikace, kter je urena cestou ke spustitelnmu souboru.
    /// Cest me bt zadno vce, bude pouita prvn existujc cesta.
    /// </summary>
    public class PathExternalApplication : ExternalApplication
    {
        public PathExternalApplication(string name, IDataWriter writer, IEnumerable<string> paths)
        {
            this.name = name;
            this.writer = writer;
            foreach (var p in paths)
            {
                if (System.IO.File.Exists(p))
                {
                    this.path = p;
                    LoadIcon();
                    available = true;
                    break;
                }
            }
        }

        private void LoadIcon()
        {
            icon = Brjnk.Common.IconsReader.GetIcon(path);
        }

        private bool available;
        private IDataWriter writer;
        private string name, path;
        private ImageSource icon;

        public override bool IsAvailable
        {
            get { return available; }
        }

        public override bool Warning
        {
            get { return false; }
        }

        public override string Name
        {
            get { return name; }
        }

        public override System.Windows.Media.ImageSource Icon
        {
            get { return icon; }
        }

        public override string Path
        {
            get { return path; }
        }

        public override IDataWriter Writer
        {
            get { return writer; }
        }
    }
}