namespace Brjnk.GpxExplorer.Workspace
{
    using Brjnk.Common;
    using Brjnk.GpxExplorer.Computing;
    using Brjnk.GpxExplorer.ViewModel;

    /// <summary>
    /// </summary>
    public class SearchPositionRequest : SearchRequest, IPoint
    {
        public SearchPositionRequest()
        {
            this.Position = new GpsCoordinates(0, 0);
        }

        private Distance maxDistance;

        public Distance MaxDistance
        {
            get { return maxDistance; }
            set
            {
                maxDistance = value; OnPropertyChanged("MaxDistance");
                OnChanged();
            }
        }

        private Distance showAgainDistance;

        public Distance ShowAgainDistance
        {
            get { return showAgainDistance; }
            set
            {
                showAgainDistance = value; OnPropertyChanged("ShowAgainDistance");
                OnChanged();
            }
        }

        public FindPositionArgs GetArgs()
        {
            if (showAgainDistance < maxDistance) System.Diagnostics.Debug.WriteLine("ShowAgainDistance je men ne MaxDistance!!");
            return new FindPositionArgs(MaxDistance, showAgainDistance, base.SearchInGaps);
        }

        private GpsCoordinates position;

        public GpsCoordinates Position
        {
            get { return position; }
            set
            {
                position = value;
                OnPropertyChanged("Position");
                GenerateStringRepresentation();
                OnChanged();
            }
        }

        protected virtual void GenerateStringRepresentation()
        {
            StringRepresentation = Position.ToString();
        }

        public GpsCoordinates GetPos()
        {
            return Position;
        }

        public override string ToString()
        {
            return position.ToString();
        }
    }
}