namespace Brjnk.GpxExplorer.Workspace
{
    using System.ComponentModel;
    using System.Windows.Media;

    /// <summary>
    /// </summary>
    public class TrackPointStyle : PointStyle, INotifyPropertyChanged
    {
        public TrackPointStyle()
        {
            base.Color = Colors.DarkGreen;
            this.PinColor = Colors.Gold;
        }

        private bool showNumber = true;

        public bool ShowNumber
        {
            get { return showNumber; }
            set { showNumber = value; OnPropertyChanged("ShowNumber"); }
        }

        private bool showDistance = false;

        public bool ShowDistance
        {
            get { return showDistance; }
            set { showDistance = value; OnPropertyChanged("ShowDistance"); }
        }

        private bool showElevation = false;

        public bool ShowElevation
        {
            get { return showElevation; }
            set { showElevation = value; OnPropertyChanged("ShowElevation"); }
        }

        private bool showDateTeim;

        public bool ShowTime
        {
            get { return showDateTeim; }
            set { showDateTeim = value; OnPropertyChanged("ShowTime"); }
        }

        private Color pinColor;

        public Color PinColor
        {
            get { return pinColor; }
            set { pinColor = value; OnPropertyChanged("PinColor"); }
        }
    }
}