namespace Brjnk.GpxExplorer.Workspace
{
    using System.ComponentModel;
    using System.Windows.Media;

    /// <summary>
    /// Uruje styl zobrazen bod
    /// </summary>
    public class WaypointStyle : PointStyle, INotifyPropertyChanged
    {
        public WaypointStyle()
        {
            PinColor = Colors.Red;
        }

        private bool showName = true;

        public bool ShowName
        {
            get { return showName; }
            set { showName = value; OnPropertyChanged("ShowName"); }
        }

        private bool showComment = false;

        public bool ShowComment
        {
            get { return showComment; }
            set { showComment = value; OnPropertyChanged("ShowComment"); }
        }

        private bool showDescription = false;

        public bool ShowDescription
        {
            get { return showDescription; }
            set { showDescription = value; OnPropertyChanged("ShowDescription"); }
        }

        private bool showElevation = true;

        public bool ShowElevation
        {
            get { return showElevation; }
            set { showElevation = value; OnPropertyChanged("ShowElevation"); }
        }

        private bool showTime = true;

        public bool ShowTime
        {
            get { return showTime; }
            set { showTime = value; OnPropertyChanged("ShowTime"); }
        }

        private bool showGCType = true;

        public bool ShowGCType
        {
            get { return showGCType; }
            set { showGCType = value; OnPropertyChanged("ShowGCType"); }
        }

        private bool showGCName = true;

        public bool ShowGCName
        {
            get { return showGCName; }
            set { showGCName = value; OnPropertyChanged("ShowGCName"); }
        }

        private bool showGCTerrain = false;

        public bool ShowGCTerrain
        {
            get { return showGCTerrain; }
            set { showGCTerrain = value; OnPropertyChanged("ShowGCTerrain"); }
        }

        private bool showGCDifficulty = false;

        public bool ShowGCDifficulty
        {
            get { return showGCDifficulty; }
            set { showGCDifficulty = value; OnPropertyChanged("ShowGCDifficulty"); }
        }

        private bool showGCSize = false;

        public bool ShowGCSize
        {
            get { return showGCSize; }
            set { showGCSize = value; OnPropertyChanged("ShowGCSize"); }
        }

        private Color pinColor;

        public Color PinColor
        {
            get { return pinColor; }
            set { pinColor = value; OnPropertyChanged("PinColor"); }
        }
    }
}