namespace Brjnk.Maps.Cache
{
    using System.Data.Entity;
    using System.Linq;

    /// <summary>
    /// </summary>
    public class MapStorageContext : DbContext
    {
        public MapStorageContext()
        {
            Database.SetInitializer(new MapStorageInitializer());
        }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            //base.OnModelCreating(modelBuilder) - vchoz implementace OnModelCreating nedl nic
        }

        public DbSet<SourceEntity> Sources { get; set; }

        public DbSet<TileEntity> Tiles { get; set; }

        private const string sqlGetTotalSize =
            "SELECT (SUM(CAST(DATALENGTH(Image) AS bigint))) From [Tiles]";

        /// <summary>
        /// Vrt velikost vech obrzk v databzi
        /// </summary>
        public long GetTotalImagesSize()
        {
            return this.Database.SqlQuery<long?>(sqlGetTotalSize).First() ?? 0;
        }

        /// <summary>
        /// Vymae dladici z databze podle id (bez nutnosti natat ji).
        /// </summary>
        public void DeleteTile(long x, long y, int zoom, int sourceId)
        {
            var entity = this.Tiles.Local.FirstOrDefault(t => t.X == x && t.Y == y && t.Zoom == zoom);
            if (entity == null)
            {
                entity = new TileEntity() { X = x, Y = y, Zoom = zoom, SourceId = sourceId };
            }
            this.Tiles.Attach(entity);
            // this.Entry(entity).State = System.Data.EntityState.Deleted;
            this.Tiles.Remove(entity);
            this.SaveChanges();
        }
    }
}