﻿using System;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace Brjnk.Maps.Cache
{
    [Table("Sources")]
    public class SourceEntity
    {
        public int ID { get; set; }

        [Required]
        public string Name { get; set; }

        /// <summary>
        /// Čas v sekundách od stažení obrázku, kdy zůstává ještě v platnosti.
        /// Po uplynutí této doby je stažen znovu.
        /// </summary>
        public int ExpirationPeriodSec { get; set; }

        [NotMapped()]
        public TimeSpan ExpirationPeriod
        {
            get { return TimeSpan.FromSeconds(ExpirationPeriodSec); }
            set { ExpirationPeriodSec = (int)value.TotalSeconds; }
        }
    }
}