﻿using System;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace Brjnk.Maps.Cache
{
    [Table("Tiles")]
    public class TileEntity
    {
        [Key, Column(Order = 0)]
        public long X { get; set; }

        [Key, Column(Order = 1)]
        public long Y { get; set; }

        [Key, Column(Order = 2)]
        public int Zoom { get; set; }

        [Key, Required, Column(Order = 3)]
        public int SourceId { get; set; }

        [ForeignKey("SourceId")]
        public SourceEntity Source { get; set; }

        [MaxLength()]
        public byte[] Image { get; set; }

        /// <summary>
        /// Datum a čas, kdy byl obrázek stažen
        /// </summary>
        public DateTime DownloadedTime { get; set; }

        [NotMapped()]
        public TileId TileId
        {
            get { return new TileId(X, Y, Zoom); }
            set { this.X = value.X; this.Y = value.Y; this.Zoom = value.Zoom; }
        }
    }
}