﻿namespace Brjnk.Maps
{
    using System.Collections.Generic;
    using System.Windows;
    using Brjnk.Maps.Downloader;

    public interface IMapProvider
    {
        Size TileDIPSize { get; }

        /// <summary>
        /// Úrovně přiblížení. Musí být seřazeny od nejmenšího přiblížení směrem k největšímu přiblížení.
        /// </summary>
        IEnumerable<ZoomLevel> ZoomLevels { get; }

        IMapProjection Projection { get; }

        GetTileTask GetTile(TileId id, DownloadTaskPriority priority, NetworkMode mode);

        Point GetTileCoordinates(Point point, int zoomLevel);

        bool IsTileAvailable(TileId id);

        void Abort();
    }
}