﻿namespace Brjnk.Maps
{
    using System;
    using Brjnk.Maps.Downloader;

    /// <summary>
    /// Omezuje množství souborů, které mohou být staženy během časového úseku
    /// </summary>
    public interface IOverloadProtection
    {
        /// <summary>
        /// Vrátí čas, za který bude možné stáhnout soubor s danou prioritou
        /// </summary>
        TimeSpan GetRemainingTime(DownloadTaskPriority priority);

        /// <summary>
        /// Omezení rychlosti stahování. Vrátí čas, po který se má vyčkat před načtením dalších dat.
        /// </summary>
        /// <param name="downloadedSize">Množství nově stažených dat</param>
        /// <returns></returns>
        TimeSpan GetSpeedRestriction(long downloadedSize);

        /// <summary>
        /// Metoda je volána při zahájení stahování
        /// </summary>
        void Increment(DownloadTaskPriority priority);
    }
}