﻿using System.Windows;
using Brjnk.Common;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Coordinate2DTest
{
    [TestClass()]
    public class UpdateableObjectTest
    {
        private TestContext testContextInstance;

        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes

        //
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //

        #endregion Additional test attributes

        internal virtual UpdateableTestObject CreateUpdateableObject(out SetPropertyHandler updater)
        {
            UpdateableTestObject target = new UpdateableTestObject(out updater);
            return target;
        }

        [TestMethod()]
        public void UpdateTest()
        {
            SetPropertyHandler updater;
            UpdateableTestObject target = CreateUpdateableObject(out updater);
            Assert.AreEqual(-1, target.Value);
            updater(UpdateableTestObject.ValueProperty, 1);
            Assert.AreEqual(1, target.Value);
        }
    }

    public class UpdateableTestObject : UpdateableObject
    {
        public UpdateableTestObject(out SetPropertyHandler updater)
            : base(out updater, false)
        {
        }

        public int Value
        {
            get { return (int)GetValue(ValueProperty); }
        }

        [OutsideUpdateable]
        private static readonly DependencyPropertyKey ValuePropertyKey =
            DependencyProperty.RegisterReadOnly("Value", typeof(int), typeof(UpdateableTestObject), new UIPropertyMetadata(-1));

        public static readonly DependencyProperty ValueProperty = ValuePropertyKey.DependencyProperty;
    }
}