﻿using System;
using System.Collections.Generic;
using Brjnk.Maps;
using Brjnk.Maps.Downloader;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace MapsTest
{
    [TestClass()]
    public class DownloaderTest
    {
        private TestContext testContextInstance;

        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes

        //
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //

        #endregion Additional test attributes

        [TestMethod()]
        public void DownloaderConstructorTest()
        {
            DefaultTimingProvider.SetDefaultTimingProvider(new TimingProvider());
            var mt = new MultiTimer();
            var scheduler = new DownloadScheduler(null, mt);
            Downloader target = new Downloader(scheduler, null);
            target.DownloadCompleted += Completed;
            target.Download(new Uri("http://192.168.0.1"), DownloadTaskPriority.Normal);
            target.Download(new Uri("http://google.cz"), DownloadTaskPriority.Normal);
            target.Download(new Uri("http://adresa.ktera.neexistuje"), DownloadTaskPriority.Normal);
            System.Threading.Thread.Sleep(8000);
            Assert.AreEqual(3, completed.Count);
            Assert.AreEqual(new Uri("http://192.168.0.1"), completed[0].Task.Uri);
            Assert.AreEqual(new Uri("http://google.cz"), completed[1].Task.Uri);
            Assert.AreEqual(new Uri("http://adresa.ktera.neexistuje"), completed[2].Task.Uri);
            Assert.AreEqual(DownloadTaskState.Success, completed[0].Task.State);
            Assert.AreEqual(DownloadTaskState.Success, completed[1].Task.State);
            Assert.AreEqual(DownloadTaskState.Failed, completed[2].Task.State);
            Assert.IsTrue(completed[0].Task.ReceivedBytes > 0 && completed[0].Task.Data.LongLength > 0);
            Assert.IsTrue(completed[1].Task.ReceivedBytes > 0 && completed[1].Task.Data.LongLength > 0);
            Assert.IsTrue(completed[2].Task.ReceivedBytes == 0 && completed[2].Task.Data.LongLength == 0);
        }

        private List<DownloadCompletedEventArgs> completed = new List<DownloadCompletedEventArgs>();

        private void Completed(object sender, DownloadCompletedEventArgs e)
        {
            completed.Add(e);
        }
    }
}