﻿using System;
using Brjnk.Maps.Downloader;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace MapsTest
{
    [TestClass()]
    public class PriorityQueueTest
    {
        private TestContext testContextInstance;

        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes

        //
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //

        #endregion Additional test attributes

        [TestMethod()]
        public void PriorityQueueConstructorTest()
        {
            var queue = new PriorityQueue<string>();
            queue.Enqueue(10, "A");
            queue.Enqueue(9, "D");
            queue.Enqueue(10, "B");
            queue.Enqueue(7, "F");
            queue.Enqueue(8, "E");
            queue.Enqueue(4, "H");
            queue.Enqueue(4, "I");
            queue.Enqueue(5, "G");
            Assert.AreEqual("A", queue.Dequeue());
            Assert.AreEqual(7, queue.Count);
            Assert.AreEqual("B,D,E,F,G,H,I", string.Join(",", queue));

            queue.Enqueue(10, "C");
            Assert.AreEqual("B", queue.Dequeue());
            Assert.AreEqual("C", queue.Dequeue());
            Assert.AreEqual("D", queue.Dequeue());
            int p;
            Assert.AreEqual("E", queue.Dequeue(out p));
            Assert.AreEqual(8, p);
            Assert.AreEqual("F", queue.Dequeue());
            Assert.AreEqual("G", queue.Dequeue());
            Assert.AreEqual("H", queue.Dequeue());
            Assert.AreEqual("I", queue.Dequeue());
            Assert.AreEqual(0, queue.Count);
        }

        [TestMethod()]
        public void PriorityQueueConstructorTest2()
        {
            var queue = new PriorityQueue<string>();
            queue.Enqueue(11, "X");
            queue.Enqueue(10, "B");
            queue.Enqueue(8, "Z");
            queue.Enqueue(9, "C");
            queue.Enqueue(11, "A");
            queue.Enqueue(12, "Y");
            queue.RemoveWhere(a => a == "X");
            queue.RemoveWhere(a => a == "Z");
            Assert.AreEqual(4, queue.Count);
            queue.RemoveWhere(a => a == "Y");
            Assert.AreEqual(3, queue.Count);
            Assert.AreEqual("A", queue.Dequeue());
            Assert.AreEqual(2, queue.Count);
            Assert.AreEqual("B", queue.Dequeue());
            Assert.AreEqual("C", queue.Dequeue());
            Assert.AreEqual(0, queue.Count);
        }

        [TestMethod(), ExpectedException(typeof(InvalidOperationException))]
        public void PriorityQueueDequeueException()
        {
            var queue = new PriorityQueue<string>();
            queue.Enqueue(10, "A");
            Assert.AreEqual("A", queue.Dequeue());
            var r = queue.Dequeue();
        }
    }
}