namespace MapsTest.TestClasses
{
    using System;
    using System.Collections.Generic;
    using Brjnk.Maps;

    /// <summary>
    /// </summary>
    public class TestTimingProvider : ITimingProvider
    {
        private TicksTime time = new TicksTime(0);
        private List<TestTimer> timers = new List<TestTimer>();

        public TicksTime GetTime()
        {
            return time;
        }

        public ITimer GetTimer()
        {
            var t = new TestTimer(this);
            timers.Add(t);
            return t;
        }

        public void Move(long ms)
        {
            System.Threading.Thread.Sleep(800);
            var oldTime = time;
            time = time.AddMilliseconds(ms);
            RaiseTick(oldTime, time);
            foreach (var timer in timers) timer.SetTime(oldTime, time);
            System.Threading.Thread.Sleep(800); //vyk aby probhly vechny akce vyvolen zmnou asu
        }

        private void RaiseTick(TicksTime oldTime, TicksTime time)
        {
            if (Tick == null) return;
            var nextTick = new TicksTime(1000 - (oldTime.Ticks % 1000) + oldTime.Ticks);
            var count = (time.Ticks - nextTick.Ticks) / 1000 + 1;
            for (int i = 0; i < count; i++) Tick(new TicksTime(nextTick.Ticks + i * 1000));
        }

        public event Action<TicksTime> Tick;
    }
}